class confirmationWindow {
    bool cShowWindow = true;
    string cWindowTitle = "Confirmation";
    string text = "Confirm your action";
    CoroutineFunc@ func;
    bool done = false;

    confirmationWindow(const string &in _text, CoroutineFunc@ _func, const string &in _cWindowTitle = "Confirmation") {
        text = _text;
        @func = _func;
        cWindowTitle = _cWindowTitle;

        if (confirmationWindows.Length != 0) confirmationWindows = {};
    }

    void show() {
        cShowWindow = true;
    }

    void hide() {
        cShowWindow = false;
    }

    void renderInterface() {
        //debug("oink");
        if (!cShowWindow) {
            if (!done) cancel();
            return;
        }
        vec2 size = vec2(250, 100);
        vec2 pos = (vec2(Draw::GetWidth(), Draw::GetHeight()) - size) / 2.;
        UI::SetNextWindowSize(int(size.x), int(size.y));
        UI::SetNextWindowPos(int(pos.x), int(pos.y));
        UI::PushStyleColor(UI::Col::FrameBg, vec4(.2, .2, .2, .5));
        if (UI::Begin(cWindowTitle, cShowWindow)) {
            renderInner();
        }
        UI::End();
        UI::PopStyleColor();
    }

    void renderInner() {
        UI::Text(text);

        UI::PushStyleColor(UI::Col::Button, ColorGreen);
        UI::PushStyleColor(UI::Col::ButtonHovered, ColorGreen*1.1);
        UI::PushStyleColor(UI::Col::ButtonActive, ColorGreen*0.9);
        if (UI::Button("Cancel")) {
            cancel();
        }
        UI::PopStyleColor(3);

        UI::SameLine();

        UI::PushStyleColor(UI::Col::Button, ColorRed);
        UI::PushStyleColor(UI::Col::ButtonHovered, ColorRed*1.1);
        UI::PushStyleColor(UI::Col::ButtonActive, ColorRed*0.9);
        if (UI::Button("Confirm")) {
            confirm();
        }
        UI::PopStyleColor(3);
    }

    void cancel() {
        done = true;
        hide();
        confirmationWindow::deleteWindow();
    }

    void confirm() {
        done = true;
        hide();
        startnew(func);
        confirmationWindow::deleteWindow();
    }
}

namespace confirmationWindow {
    void deleteWindow() {
        confirmationWindows.RemoveLast();
    }
}