class mem {
    dictionary@ d;
    string filePath = IO::FromStorageFolder("mem.db");
    bool initialized = false;
    uint16 version = 0;

    mem() {
        @d = dictionary();
    }

    void LoadMem() {
        if (IO::FileExists(filePath)) {
            IO::File f(filePath, IO::FileMode::Read);
            MemoryBuffer@ buf = MemoryBuffer(f.Read(f.Size()));
            f.Close();

            version = buf.AtEnd() ? 0 : buf.ReadUInt16();
            trace("memory current version : "+ version + " ; newest version : " + dataBaseVersion);
            if (version != dataBaseVersion) {
                Clear();
                version = dataBaseVersion;
                setVersion(dataBaseVersion);
                initialized = true;
                return;
            }
            uint cnt = 100;
            while (!buf.AtEnd()) {
                auto kvp = mem::kvPair::readFromBuffer(buf);
                @d[kvp.key] = kvp.val;
                cnt--;
                if (cnt <= 0) {
                    cnt = 100;
                    yield(); // yield every 100 campaigns to give space for other
                }
            }
        }
        else {
            version = dataBaseVersion;
            setVersion(dataBaseVersion);
        }
        initialized = true;
    }

    void setVersion(uint16 v) {
        MemoryBuffer@ buf = MemoryBuffer();
        buf.Write(v);
        IO::File f(filePath, IO::FileMode::Write);
        f.Write(buf);
        f.Close();
    }

    campaignInfo@ Get(const string &in key) {
        return cast<campaignInfo@>(d[key]);
    }

    bool In(const string &in key) {
        return d.Exists(key);
    }

    string[] GetKeys() {
        return d.GetKeys();
    }

    void Set(const string &in key, campaignInfo@ val) {
        @d[key] = val;
        mem::kvPair@ kvp = mem::kvPair(key, val);
        MemoryBuffer@ buf = MemoryBuffer();
        kvp.writeToBuffer(buf);
        buf.Seek(0, 0);
        IO::File f(filePath, IO::FileMode::Append);
        f.Write(buf);
        f.Close();
    }

    void Clear() {
        orderedKeys = {};
        filteredMaps = {};
        d.DeleteAll();
        setVersion(dataBaseVersion);
    }
}
namespace mem {
    class kvPair {
        string key;
        campaignInfo@ val = campaignInfo();

        kvPair(const string &in _key, campaignInfo@ _val) {
            val = _val;
            key = _key;
        }

        void writeToBuffer(MemoryBuffer@ buf) {
            STB(buf, key);
            val.writeToBuffer(buf);
        }

        void STB(MemoryBuffer@ buf, const string &in s) {
            uint32 len = s.Length;
            buf.Write(len);
            buf.Write(s);
        }
    }

    namespace kvPair {
        kvPair@ readFromBuffer(MemoryBuffer@ buf) {
            string key = SFB(buf);
            campaignInfo@ val = campaignInfo::readFromBuffer(buf);
            return kvPair(key, val);
        }

        string SFB(MemoryBuffer@ buf) {
            uint32 len = buf.ReadUInt32();
            string s = buf.ReadString(len);
            return s;
        }
    }
}