namespace overide {
    dictionary@ mapOverideDict;

    bool initialized = false;

    void LoadOveride() {
        @mapOverideDict = dictionary();

        Net::HttpRequest@ req = Net::HttpGet(develepor ? "https://openplanet.dev/plugin/royal-hub/config/overide-dev" : "https://openplanet.dev/plugin/royal-hub/config/overide");
        while (!req.Finished()) yield();
        if (req.ResponseCode() != 200) {
            error("bad response code. Check network log!");
            trace(develepor ? "https://openplanet.dev/plugin/royal-hub/config/overide-dev" : "https://openplanet.dev/plugin/royal-hub/config/overide");
            return;
        }

        Json::Value json = req.Json();

        for (uint i = 0; i < json.Length; i++) {
            if (json[i]["type"] == "map") OverideMap(json[i]);
        }

        initialized = true;
    }

    void OverideMap(Json::Value json) {
        if (!isOlderVersion(json["versionRequirement"])) return;
        string trackId = json["trackId"];

        mapInfo::mapInfoOveride mio;

        if (json["overide"].HasKey("difficulty")) mio.difficulty = json["overide"]["difficulty"];
        if (json["overide"].HasKey("name")) mio.name = json["overide"]["name"];

        @mapOverideDict[trackId] = mio;
    }
}